console.log("running...");

function initFields() {
    console.log("initializing fields");
    
    var date = new Date();

    document.querySelectorAll(".date-day").forEach((node) => {
        node.value = date.getDate();
    });

    document.querySelectorAll(".date-month").forEach((node) => {
        node.selectedIndex = date.getMonth();
    });

    document.querySelectorAll(".date-year").forEach((node) => {
        node.value = date.getFullYear();
    });

    document.querySelectorAll(".date-today").forEach((node) => {
        node.value = date.toISOString().substring(0, 10);
    });

    document.querySelectorAll(".physician-name").forEach((node) => {
        node.value = window.localStorage.getItem("physician-name");
    });
}

function setupCallbacks() {
    /* patient name */

    [".physician-name",
     ".patient-name",
     ".patient-residence",
     ".patient-birth",
     ".patient-relative",
     ".patient-proxy",
     ".patient-guardian"].forEach((tag) => {
        var nodes = document.querySelectorAll(tag);
        nodes.forEach((node) => {
            node.addEventListener("input", (event) => {
                nodes.forEach((node) => {
                    node.value = event.target.value;
                });
            });
        });
     });

    [".patient-relative",
     ".patient-proxy",
     ".patient-guardian",
     ".patient-relative-address"].forEach((tag) => {
         var nodes = document.querySelectorAll(tag);
         nodes.forEach((node) => {
             node.addEventListener("input", (event) => {
                 var name = document.querySelector(".patient-relative").value ||
                     document.querySelector(".patient-proxy").value ||
                     document.querySelector(".patient-guardian").value;
                     
                 var address = document.querySelector(".patient-relative-address").value;
                 var separator = " -- ";

                 if (! (name && address)) {
                     separator = "";
                 }

                 document.querySelector(".patient-relative-full").value = name + separator + document.querySelector(".patient-relative-address").value;
             });
         });
     });

    document.querySelectorAll(".physician-name").forEach((node) => {
        node.addEventListener("input", (event) => {
            window.localStorage.setItem("physician-name", event.target.value);
        });
    });
}

window.addEventListener('DOMContentLoaded', () => {
    initFields();
    setupCallbacks();
});
